{
    x86 format converters for HERMES
    Some routines Copyright (c) 1998 Christian Nentwich (c.nentwich@cs.ucl.ac.uk)
    Some routines are (c) Glenn Fiedler (ptc@gaffer.org), used with permission

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version
    with the following modification:

    As a special exception, the copyright holders of this library give you
    permission to link this library with independent modules to produce an
    executable, regardless of the license terms of these independent modules,and
    to copy and distribute the resulting executable under terms of your choice,
    provided that you also meet, for each linked independent module, the terms
    and conditions of the license of that module. An independent module is a
    module which is not derived from or based on this library. If you modify
    this library, you may extend this exception to your version of the library,
    but you are not obligated to do so. If you do not wish to do so, delete this
    exception statement from your version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}

const
  ConvertX86p16_32RGB888_LUT_X86: array [0..511] of DWord = (
                  $00000
                , $00000
                , $00008
                , $02000
                , $00010
                , $04000
                , $00018
                , $06100
                , $00020
                , $08100
                , $00029
                , $0a100
                , $00031
                , $0c200
                , $00039
                , $0e200
                , $00041
                , $80000
                , $0004a
                , $82000
                , $00052
                , $84000
                , $0005a
                , $86100
                , $00062
                , $88100
                , $0006a
                , $8a100
                , $00073
                , $8c200
                , $0007b
                , $8e200
                , $00083
                , $100000
                , $0008b
                , $102000
                , $00094
                , $104000
                , $0009c
                , $106100
                , $000a4
                , $108100
                , $000ac
                , $10a100
                , $000b4
                , $10c200
                , $000bd
                , $10e200
                , $000c5
                , $180000
                , $000cd
                , $182000
                , $000d5
                , $184000
                , $000de
                , $186100
                , $000e6
                , $188100
                , $000ee
                , $18a100
                , $000f6
                , $18c200
                , $000ff
                , $18e200
                , $00400
                , $200000
                , $00408
                , $202000
                , $00410
                , $204000
                , $00418
                , $206100
                , $00420
                , $208100
                , $00429
                , $20a100
                , $00431
                , $20c200
                , $00439
                , $20e200
                , $00441
                , $290000
                , $0044a
                , $292000
                , $00452
                , $294000
                , $0045a
                , $296100
                , $00462
                , $298100
                , $0046a
                , $29a100
                , $00473
                , $29c200
                , $0047b
                , $29e200
                , $00483
                , $310000
                , $0048b
                , $312000
                , $00494
                , $314000
                , $0049c
                , $316100
                , $004a4
                , $318100
                , $004ac
                , $31a100
                , $004b4
                , $31c200
                , $004bd
                , $31e200
                , $004c5
                , $390000
                , $004cd
                , $392000
                , $004d5
                , $394000
                , $004de
                , $396100
                , $004e6
                , $398100
                , $004ee
                , $39a100
                , $004f6
                , $39c200
                , $004ff
                , $39e200
                , $00800
                , $410000
                , $00808
                , $412000
                , $00810
                , $414000
                , $00818
                , $416100
                , $00820
                , $418100
                , $00829
                , $41a100
                , $00831
                , $41c200
                , $00839
                , $41e200
                , $00841
                , $4a0000
                , $0084a
                , $4a2000
                , $00852
                , $4a4000
                , $0085a
                , $4a6100
                , $00862
                , $4a8100
                , $0086a
                , $4aa100
                , $00873
                , $4ac200
                , $0087b
                , $4ae200
                , $00883
                , $520000
                , $0088b
                , $522000
                , $00894
                , $524000
                , $0089c
                , $526100
                , $008a4
                , $528100
                , $008ac
                , $52a100
                , $008b4
                , $52c200
                , $008bd
                , $52e200
                , $008c5
                , $5a0000
                , $008cd
                , $5a2000
                , $008d5
                , $5a4000
                , $008de
                , $5a6100
                , $008e6
                , $5a8100
                , $008ee
                , $5aa100
                , $008f6
                , $5ac200
                , $008ff
                , $5ae200
                , $00c00
                , $620000
                , $00c08
                , $622000
                , $00c10
                , $624000
                , $00c18
                , $626100
                , $00c20
                , $628100
                , $00c29
                , $62a100
                , $00c31
                , $62c200
                , $00c39
                , $62e200
                , $00c41
                , $6a0000
                , $00c4a
                , $6a2000
                , $00c52
                , $6a4000
                , $00c5a
                , $6a6100
                , $00c62
                , $6a8100
                , $00c6a
                , $6aa100
                , $00c73
                , $6ac200
                , $00c7b
                , $6ae200
                , $00c83
                , $730000
                , $00c8b
                , $732000
                , $00c94
                , $734000
                , $00c9c
                , $736100
                , $00ca4
                , $738100
                , $00cac
                , $73a100
                , $00cb4
                , $73c200
                , $00cbd
                , $73e200
                , $00cc5
                , $7b0000
                , $00ccd
                , $7b2000
                , $00cd5
                , $7b4000
                , $00cde
                , $7b6100
                , $00ce6
                , $7b8100
                , $00cee
                , $7ba100
                , $00cf6
                , $7bc200
                , $00cff
                , $7be200
                , $01000
                , $830000
                , $01008
                , $832000
                , $01010
                , $834000
                , $01018
                , $836100
                , $01020
                , $838100
                , $01029
                , $83a100
                , $01031
                , $83c200
                , $01039
                , $83e200
                , $01041
                , $8b0000
                , $0104a
                , $8b2000
                , $01052
                , $8b4000
                , $0105a
                , $8b6100
                , $01062
                , $8b8100
                , $0106a
                , $8ba100
                , $01073
                , $8bc200
                , $0107b
                , $8be200
                , $01083
                , $940000
                , $0108b
                , $942000
                , $01094
                , $944000
                , $0109c
                , $946100
                , $010a4
                , $948100
                , $010ac
                , $94a100
                , $010b4
                , $94c200
                , $010bd
                , $94e200
                , $010c5
                , $9c0000
                , $010cd
                , $9c2000
                , $010d5
                , $9c4000
                , $010de
                , $9c6100
                , $010e6
                , $9c8100
                , $010ee
                , $9ca100
                , $010f6
                , $9cc200
                , $010ff
                , $9ce200
                , $01400
                , $a40000
                , $01408
                , $a42000
                , $01410
                , $a44000
                , $01418
                , $a46100
                , $01420
                , $a48100
                , $01429
                , $a4a100
                , $01431
                , $a4c200
                , $01439
                , $a4e200
                , $01441
                , $ac0000
                , $0144a
                , $ac2000
                , $01452
                , $ac4000
                , $0145a
                , $ac6100
                , $01462
                , $ac8100
                , $0146a
                , $aca100
                , $01473
                , $acc200
                , $0147b
                , $ace200
                , $01483
                , $b40000
                , $0148b
                , $b42000
                , $01494
                , $b44000
                , $0149c
                , $b46100
                , $014a4
                , $b48100
                , $014ac
                , $b4a100
                , $014b4
                , $b4c200
                , $014bd
                , $b4e200
                , $014c5
                , $bd0000
                , $014cd
                , $bd2000
                , $014d5
                , $bd4000
                , $014de
                , $bd6100
                , $014e6
                , $bd8100
                , $014ee
                , $bda100
                , $014f6
                , $bdc200
                , $014ff
                , $bde200
                , $01800
                , $c50000
                , $01808
                , $c52000
                , $01810
                , $c54000
                , $01818
                , $c56100
                , $01820
                , $c58100
                , $01829
                , $c5a100
                , $01831
                , $c5c200
                , $01839
                , $c5e200
                , $01841
                , $cd0000
                , $0184a
                , $cd2000
                , $01852
                , $cd4000
                , $0185a
                , $cd6100
                , $01862
                , $cd8100
                , $0186a
                , $cda100
                , $01873
                , $cdc200
                , $0187b
                , $cde200
                , $01883
                , $d50000
                , $0188b
                , $d52000
                , $01894
                , $d54000
                , $0189c
                , $d56100
                , $018a4
                , $d58100
                , $018ac
                , $d5a100
                , $018b4
                , $d5c200
                , $018bd
                , $d5e200
                , $018c5
                , $de0000
                , $018cd
                , $de2000
                , $018d5
                , $de4000
                , $018de
                , $de6100
                , $018e6
                , $de8100
                , $018ee
                , $dea100
                , $018f6
                , $dec200
                , $018ff
                , $dee200
                , $01c00
                , $e60000
                , $01c08
                , $e62000
                , $01c10
                , $e64000
                , $01c18
                , $e66100
                , $01c20
                , $e68100
                , $01c29
                , $e6a100
                , $01c31
                , $e6c200
                , $01c39
                , $e6e200
                , $01c41
                , $ee0000
                , $01c4a
                , $ee2000
                , $01c52
                , $ee4000
                , $01c5a
                , $ee6100
                , $01c62
                , $ee8100
                , $01c6a
                , $eea100
                , $01c73
                , $eec200
                , $01c7b
                , $eee200
                , $01c83
                , $f60000
                , $01c8b
                , $f62000
                , $01c94
                , $f64000
                , $01c9c
                , $f66100
                , $01ca4
                , $f68100
                , $01cac
                , $f6a100
                , $01cb4
                , $f6c200
                , $01cbd
                , $f6e200
                , $01cc5
                , $ff0000
                , $01ccd
                , $ff2000
                , $01cd5
                , $ff4000
                , $01cde
                , $ff6100
                , $01ce6
                , $ff8100
                , $01cee
                , $ffa100
                , $01cf6
                , $ffc200
                , $01cff
                , $ffe200);

  ConvertX86p16_32BGR888_LUT_X86: array [0..511] of DWord = (
                  $00000
                , $00000
                , $80000
                , $02000
                , $100000
                , $04000
                , $180000
                , $06100
                , $200000
                , $08100
                , $290000
                , $0a100
                , $310000
                , $0c200
                , $390000
                , $0e200
                , $410000
                , $00008
                , $4a0000
                , $02008
                , $520000
                , $04008
                , $5a0000
                , $06108
                , $620000
                , $08108
                , $6a0000
                , $0a108
                , $730000
                , $0c208
                , $7b0000
                , $0e208
                , $830000
                , $00010
                , $8b0000
                , $02010
                , $940000
                , $04010
                , $9c0000
                , $06110
                , $a40000
                , $08110
                , $ac0000
                , $0a110
                , $b40000
                , $0c210
                , $bd0000
                , $0e210
                , $c50000
                , $00018
                , $cd0000
                , $02018
                , $d50000
                , $04018
                , $de0000
                , $06118
                , $e60000
                , $08118
                , $ee0000
                , $0a118
                , $f60000
                , $0c218
                , $ff0000
                , $0e218
                , $00400
                , $00020
                , $80400
                , $02020
                , $100400
                , $04020
                , $180400
                , $06120
                , $200400
                , $08120
                , $290400
                , $0a120
                , $310400
                , $0c220
                , $390400
                , $0e220
                , $410400
                , $00029
                , $4a0400
                , $02029
                , $520400
                , $04029
                , $5a0400
                , $06129
                , $620400
                , $08129
                , $6a0400
                , $0a129
                , $730400
                , $0c229
                , $7b0400
                , $0e229
                , $830400
                , $00031
                , $8b0400
                , $02031
                , $940400
                , $04031
                , $9c0400
                , $06131
                , $a40400
                , $08131
                , $ac0400
                , $0a131
                , $b40400
                , $0c231
                , $bd0400
                , $0e231
                , $c50400
                , $00039
                , $cd0400
                , $02039
                , $d50400
                , $04039
                , $de0400
                , $06139
                , $e60400
                , $08139
                , $ee0400
                , $0a139
                , $f60400
                , $0c239
                , $ff0400
                , $0e239
                , $00800
                , $00041
                , $80800
                , $02041
                , $100800
                , $04041
                , $180800
                , $06141
                , $200800
                , $08141
                , $290800
                , $0a141
                , $310800
                , $0c241
                , $390800
                , $0e241
                , $410800
                , $0004a
                , $4a0800
                , $0204a
                , $520800
                , $0404a
                , $5a0800
                , $0614a
                , $620800
                , $0814a
                , $6a0800
                , $0a14a
                , $730800
                , $0c24a
                , $7b0800
                , $0e24a
                , $830800
                , $00052
                , $8b0800
                , $02052
                , $940800
                , $04052
                , $9c0800
                , $06152
                , $a40800
                , $08152
                , $ac0800
                , $0a152
                , $b40800
                , $0c252
                , $bd0800
                , $0e252
                , $c50800
                , $0005a
                , $cd0800
                , $0205a
                , $d50800
                , $0405a
                , $de0800
                , $0615a
                , $e60800
                , $0815a
                , $ee0800
                , $0a15a
                , $f60800
                , $0c25a
                , $ff0800
                , $0e25a
                , $00c00
                , $00062
                , $80c00
                , $02062
                , $100c00
                , $04062
                , $180c00
                , $06162
                , $200c00
                , $08162
                , $290c00
                , $0a162
                , $310c00
                , $0c262
                , $390c00
                , $0e262
                , $410c00
                , $0006a
                , $4a0c00
                , $0206a
                , $520c00
                , $0406a
                , $5a0c00
                , $0616a
                , $620c00
                , $0816a
                , $6a0c00
                , $0a16a
                , $730c00
                , $0c26a
                , $7b0c00
                , $0e26a
                , $830c00
                , $00073
                , $8b0c00
                , $02073
                , $940c00
                , $04073
                , $9c0c00
                , $06173
                , $a40c00
                , $08173
                , $ac0c00
                , $0a173
                , $b40c00
                , $0c273
                , $bd0c00
                , $0e273
                , $c50c00
                , $0007b
                , $cd0c00
                , $0207b
                , $d50c00
                , $0407b
                , $de0c00
                , $0617b
                , $e60c00
                , $0817b
                , $ee0c00
                , $0a17b
                , $f60c00
                , $0c27b
                , $ff0c00
                , $0e27b
                , $01000
                , $00083
                , $81000
                , $02083
                , $101000
                , $04083
                , $181000
                , $06183
                , $201000
                , $08183
                , $291000
                , $0a183
                , $311000
                , $0c283
                , $391000
                , $0e283
                , $411000
                , $0008b
                , $4a1000
                , $0208b
                , $521000
                , $0408b
                , $5a1000
                , $0618b
                , $621000
                , $0818b
                , $6a1000
                , $0a18b
                , $731000
                , $0c28b
                , $7b1000
                , $0e28b
                , $831000
                , $00094
                , $8b1000
                , $02094
                , $941000
                , $04094
                , $9c1000
                , $06194
                , $a41000
                , $08194
                , $ac1000
                , $0a194
                , $b41000
                , $0c294
                , $bd1000
                , $0e294
                , $c51000
                , $0009c
                , $cd1000
                , $0209c
                , $d51000
                , $0409c
                , $de1000
                , $0619c
                , $e61000
                , $0819c
                , $ee1000
                , $0a19c
                , $f61000
                , $0c29c
                , $ff1000
                , $0e29c
                , $01400
                , $000a4
                , $81400
                , $020a4
                , $101400
                , $040a4
                , $181400
                , $061a4
                , $201400
                , $081a4
                , $291400
                , $0a1a4
                , $311400
                , $0c2a4
                , $391400
                , $0e2a4
                , $411400
                , $000ac
                , $4a1400
                , $020ac
                , $521400
                , $040ac
                , $5a1400
                , $061ac
                , $621400
                , $081ac
                , $6a1400
                , $0a1ac
                , $731400
                , $0c2ac
                , $7b1400
                , $0e2ac
                , $831400
                , $000b4
                , $8b1400
                , $020b4
                , $941400
                , $040b4
                , $9c1400
                , $061b4
                , $a41400
                , $081b4
                , $ac1400
                , $0a1b4
                , $b41400
                , $0c2b4
                , $bd1400
                , $0e2b4
                , $c51400
                , $000bd
                , $cd1400
                , $020bd
                , $d51400
                , $040bd
                , $de1400
                , $061bd
                , $e61400
                , $081bd
                , $ee1400
                , $0a1bd
                , $f61400
                , $0c2bd
                , $ff1400
                , $0e2bd
                , $01800
                , $000c5
                , $81800
                , $020c5
                , $101800
                , $040c5
                , $181800
                , $061c5
                , $201800
                , $081c5
                , $291800
                , $0a1c5
                , $311800
                , $0c2c5
                , $391800
                , $0e2c5
                , $411800
                , $000cd
                , $4a1800
                , $020cd
                , $521800
                , $040cd
                , $5a1800
                , $061cd
                , $621800
                , $081cd
                , $6a1800
                , $0a1cd
                , $731800
                , $0c2cd
                , $7b1800
                , $0e2cd
                , $831800
                , $000d5
                , $8b1800
                , $020d5
                , $941800
                , $040d5
                , $9c1800
                , $061d5
                , $a41800
                , $081d5
                , $ac1800
                , $0a1d5
                , $b41800
                , $0c2d5
                , $bd1800
                , $0e2d5
                , $c51800
                , $000de
                , $cd1800
                , $020de
                , $d51800
                , $040de
                , $de1800
                , $061de
                , $e61800
                , $081de
                , $ee1800
                , $0a1de
                , $f61800
                , $0c2de
                , $ff1800
                , $0e2de
                , $01c00
                , $000e6
                , $81c00
                , $020e6
                , $101c00
                , $040e6
                , $181c00
                , $061e6
                , $201c00
                , $081e6
                , $291c00
                , $0a1e6
                , $311c00
                , $0c2e6
                , $391c00
                , $0e2e6
                , $411c00
                , $000ee
                , $4a1c00
                , $020ee
                , $521c00
                , $040ee
                , $5a1c00
                , $061ee
                , $621c00
                , $081ee
                , $6a1c00
                , $0a1ee
                , $731c00
                , $0c2ee
                , $7b1c00
                , $0e2ee
                , $831c00
                , $000f6
                , $8b1c00
                , $020f6
                , $941c00
                , $040f6
                , $9c1c00
                , $061f6
                , $a41c00
                , $081f6
                , $ac1c00
                , $0a1f6
                , $b41c00
                , $0c2f6
                , $bd1c00
                , $0e2f6
                , $c51c00
                , $000ff
                , $cd1c00
                , $020ff
                , $d51c00
                , $040ff
                , $de1c00
                , $061ff
                , $e61c00
                , $081ff
                , $ee1c00
                , $0a1ff
                , $f61c00
                , $0c2ff
                , $ff1c00
                , $0e2ff);

  ConvertX86p16_32RGBA888_LUT_X86: array [0..511] of DWord = (
                  $00000
                , $000ff
                , $00800
                , $2000ff
                , $01000
                , $4000ff
                , $01800
                , $6100ff
                , $02000
                , $8100ff
                , $02900
                , $a100ff
                , $03100
                , $c200ff
                , $03900
                , $e200ff
                , $04100
                , $80000ff
                , $04a00
                , $82000ff
                , $05200
                , $84000ff
                , $05a00
                , $86100ff
                , $06200
                , $88100ff
                , $06a00
                , $8a100ff
                , $07300
                , $8c200ff
                , $07b00
                , $8e200ff
                , $08300
                , $100000ff
                , $08b00
                , $102000ff
                , $09400
                , $104000ff
                , $09c00
                , $106100ff
                , $0a400
                , $108100ff
                , $0ac00
                , $10a100ff
                , $0b400
                , $10c200ff
                , $0bd00
                , $10e200ff
                , $0c500
                , $180000ff
                , $0cd00
                , $182000ff
                , $0d500
                , $184000ff
                , $0de00
                , $186100ff
                , $0e600
                , $188100ff
                , $0ee00
                , $18a100ff
                , $0f600
                , $18c200ff
                , $0ff00
                , $18e200ff
                , $40000
                , $200000ff
                , $40800
                , $202000ff
                , $41000
                , $204000ff
                , $41800
                , $206100ff
                , $42000
                , $208100ff
                , $42900
                , $20a100ff
                , $43100
                , $20c200ff
                , $43900
                , $20e200ff
                , $44100
                , $290000ff
                , $44a00
                , $292000ff
                , $45200
                , $294000ff
                , $45a00
                , $296100ff
                , $46200
                , $298100ff
                , $46a00
                , $29a100ff
                , $47300
                , $29c200ff
                , $47b00
                , $29e200ff
                , $48300
                , $310000ff
                , $48b00
                , $312000ff
                , $49400
                , $314000ff
                , $49c00
                , $316100ff
                , $4a400
                , $318100ff
                , $4ac00
                , $31a100ff
                , $4b400
                , $31c200ff
                , $4bd00
                , $31e200ff
                , $4c500
                , $390000ff
                , $4cd00
                , $392000ff
                , $4d500
                , $394000ff
                , $4de00
                , $396100ff
                , $4e600
                , $398100ff
                , $4ee00
                , $39a100ff
                , $4f600
                , $39c200ff
                , $4ff00
                , $39e200ff
                , $80000
                , $410000ff
                , $80800
                , $412000ff
                , $81000
                , $414000ff
                , $81800
                , $416100ff
                , $82000
                , $418100ff
                , $82900
                , $41a100ff
                , $83100
                , $41c200ff
                , $83900
                , $41e200ff
                , $84100
                , $4a0000ff
                , $84a00
                , $4a2000ff
                , $85200
                , $4a4000ff
                , $85a00
                , $4a6100ff
                , $86200
                , $4a8100ff
                , $86a00
                , $4aa100ff
                , $87300
                , $4ac200ff
                , $87b00
                , $4ae200ff
                , $88300
                , $520000ff
                , $88b00
                , $522000ff
                , $89400
                , $524000ff
                , $89c00
                , $526100ff
                , $8a400
                , $528100ff
                , $8ac00
                , $52a100ff
                , $8b400
                , $52c200ff
                , $8bd00
                , $52e200ff
                , $8c500
                , $5a0000ff
                , $8cd00
                , $5a2000ff
                , $8d500
                , $5a4000ff
                , $8de00
                , $5a6100ff
                , $8e600
                , $5a8100ff
                , $8ee00
                , $5aa100ff
                , $8f600
                , $5ac200ff
                , $8ff00
                , $5ae200ff
                , $c0000
                , $620000ff
                , $c0800
                , $622000ff
                , $c1000
                , $624000ff
                , $c1800
                , $626100ff
                , $c2000
                , $628100ff
                , $c2900
                , $62a100ff
                , $c3100
                , $62c200ff
                , $c3900
                , $62e200ff
                , $c4100
                , $6a0000ff
                , $c4a00
                , $6a2000ff
                , $c5200
                , $6a4000ff
                , $c5a00
                , $6a6100ff
                , $c6200
                , $6a8100ff
                , $c6a00
                , $6aa100ff
                , $c7300
                , $6ac200ff
                , $c7b00
                , $6ae200ff
                , $c8300
                , $730000ff
                , $c8b00
                , $732000ff
                , $c9400
                , $734000ff
                , $c9c00
                , $736100ff
                , $ca400
                , $738100ff
                , $cac00
                , $73a100ff
                , $cb400
                , $73c200ff
                , $cbd00
                , $73e200ff
                , $cc500
                , $7b0000ff
                , $ccd00
                , $7b2000ff
                , $cd500
                , $7b4000ff
                , $cde00
                , $7b6100ff
                , $ce600
                , $7b8100ff
                , $cee00
                , $7ba100ff
                , $cf600
                , $7bc200ff
                , $cff00
                , $7be200ff
                , $100000
                , $830000ff
                , $100800
                , $832000ff
                , $101000
                , $834000ff
                , $101800
                , $836100ff
                , $102000
                , $838100ff
                , $102900
                , $83a100ff
                , $103100
                , $83c200ff
                , $103900
                , $83e200ff
                , $104100
                , $8b0000ff
                , $104a00
                , $8b2000ff
                , $105200
                , $8b4000ff
                , $105a00
                , $8b6100ff
                , $106200
                , $8b8100ff
                , $106a00
                , $8ba100ff
                , $107300
                , $8bc200ff
                , $107b00
                , $8be200ff
                , $108300
                , $940000ff
                , $108b00
                , $942000ff
                , $109400
                , $944000ff
                , $109c00
                , $946100ff
                , $10a400
                , $948100ff
                , $10ac00
                , $94a100ff
                , $10b400
                , $94c200ff
                , $10bd00
                , $94e200ff
                , $10c500
                , $9c0000ff
                , $10cd00
                , $9c2000ff
                , $10d500
                , $9c4000ff
                , $10de00
                , $9c6100ff
                , $10e600
                , $9c8100ff
                , $10ee00
                , $9ca100ff
                , $10f600
                , $9cc200ff
                , $10ff00
                , $9ce200ff
                , $140000
                , $a40000ff
                , $140800
                , $a42000ff
                , $141000
                , $a44000ff
                , $141800
                , $a46100ff
                , $142000
                , $a48100ff
                , $142900
                , $a4a100ff
                , $143100
                , $a4c200ff
                , $143900
                , $a4e200ff
                , $144100
                , $ac0000ff
                , $144a00
                , $ac2000ff
                , $145200
                , $ac4000ff
                , $145a00
                , $ac6100ff
                , $146200
                , $ac8100ff
                , $146a00
                , $aca100ff
                , $147300
                , $acc200ff
                , $147b00
                , $ace200ff
                , $148300
                , $b40000ff
                , $148b00
                , $b42000ff
                , $149400
                , $b44000ff
                , $149c00
                , $b46100ff
                , $14a400
                , $b48100ff
                , $14ac00
                , $b4a100ff
                , $14b400
                , $b4c200ff
                , $14bd00
                , $b4e200ff
                , $14c500
                , $bd0000ff
                , $14cd00
                , $bd2000ff
                , $14d500
                , $bd4000ff
                , $14de00
                , $bd6100ff
                , $14e600
                , $bd8100ff
                , $14ee00
                , $bda100ff
                , $14f600
                , $bdc200ff
                , $14ff00
                , $bde200ff
                , $180000
                , $c50000ff
                , $180800
                , $c52000ff
                , $181000
                , $c54000ff
                , $181800
                , $c56100ff
                , $182000
                , $c58100ff
                , $182900
                , $c5a100ff
                , $183100
                , $c5c200ff
                , $183900
                , $c5e200ff
                , $184100
                , $cd0000ff
                , $184a00
                , $cd2000ff
                , $185200
                , $cd4000ff
                , $185a00
                , $cd6100ff
                , $186200
                , $cd8100ff
                , $186a00
                , $cda100ff
                , $187300
                , $cdc200ff
                , $187b00
                , $cde200ff
                , $188300
                , $d50000ff
                , $188b00
                , $d52000ff
                , $189400
                , $d54000ff
                , $189c00
                , $d56100ff
                , $18a400
                , $d58100ff
                , $18ac00
                , $d5a100ff
                , $18b400
                , $d5c200ff
                , $18bd00
                , $d5e200ff
                , $18c500
                , $de0000ff
                , $18cd00
                , $de2000ff
                , $18d500
                , $de4000ff
                , $18de00
                , $de6100ff
                , $18e600
                , $de8100ff
                , $18ee00
                , $dea100ff
                , $18f600
                , $dec200ff
                , $18ff00
                , $dee200ff
                , $1c0000
                , $e60000ff
                , $1c0800
                , $e62000ff
                , $1c1000
                , $e64000ff
                , $1c1800
                , $e66100ff
                , $1c2000
                , $e68100ff
                , $1c2900
                , $e6a100ff
                , $1c3100
                , $e6c200ff
                , $1c3900
                , $e6e200ff
                , $1c4100
                , $ee0000ff
                , $1c4a00
                , $ee2000ff
                , $1c5200
                , $ee4000ff
                , $1c5a00
                , $ee6100ff
                , $1c6200
                , $ee8100ff
                , $1c6a00
                , $eea100ff
                , $1c7300
                , $eec200ff
                , $1c7b00
                , $eee200ff
                , $1c8300
                , $f60000ff
                , $1c8b00
                , $f62000ff
                , $1c9400
                , $f64000ff
                , $1c9c00
                , $f66100ff
                , $1ca400
                , $f68100ff
                , $1cac00
                , $f6a100ff
                , $1cb400
                , $f6c200ff
                , $1cbd00
                , $f6e200ff
                , $1cc500
                , $ff0000ff
                , $1ccd00
                , $ff2000ff
                , $1cd500
                , $ff4000ff
                , $1cde00
                , $ff6100ff
                , $1ce600
                , $ff8100ff
                , $1cee00
                , $ffa100ff
                , $1cf600
                , $ffc200ff
                , $1cff00
                , $ffe200ff);

  ConvertX86p16_32BGRA888_LUT_X86: array [0..511] of DWord = (
                  $00000
                , $000ff
                , $8000000
                , $2000ff
                , $10000000
                , $4000ff
                , $18000000
                , $6100ff
                , $20000000
                , $8100ff
                , $29000000
                , $a100ff
                , $31000000
                , $c200ff
                , $39000000
                , $e200ff
                , $41000000
                , $008ff
                , $4a000000
                , $2008ff
                , $52000000
                , $4008ff
                , $5a000000
                , $6108ff
                , $62000000
                , $8108ff
                , $6a000000
                , $a108ff
                , $73000000
                , $c208ff
                , $7b000000
                , $e208ff
                , $83000000
                , $010ff
                , $8b000000
                , $2010ff
                , $94000000
                , $4010ff
                , $9c000000
                , $6110ff
                , $a4000000
                , $8110ff
                , $ac000000
                , $a110ff
                , $b4000000
                , $c210ff
                , $bd000000
                , $e210ff
                , $c5000000
                , $018ff
                , $cd000000
                , $2018ff
                , $d5000000
                , $4018ff
                , $de000000
                , $6118ff
                , $e6000000
                , $8118ff
                , $ee000000
                , $a118ff
                , $f6000000
                , $c218ff
                , $ff000000
                , $e218ff
                , $40000
                , $020ff
                , $8040000
                , $2020ff
                , $10040000
                , $4020ff
                , $18040000
                , $6120ff
                , $20040000
                , $8120ff
                , $29040000
                , $a120ff
                , $31040000
                , $c220ff
                , $39040000
                , $e220ff
                , $41040000
                , $029ff
                , $4a040000
                , $2029ff
                , $52040000
                , $4029ff
                , $5a040000
                , $6129ff
                , $62040000
                , $8129ff
                , $6a040000
                , $a129ff
                , $73040000
                , $c229ff
                , $7b040000
                , $e229ff
                , $83040000
                , $031ff
                , $8b040000
                , $2031ff
                , $94040000
                , $4031ff
                , $9c040000
                , $6131ff
                , $a4040000
                , $8131ff
                , $ac040000
                , $a131ff
                , $b4040000
                , $c231ff
                , $bd040000
                , $e231ff
                , $c5040000
                , $039ff
                , $cd040000
                , $2039ff
                , $d5040000
                , $4039ff
                , $de040000
                , $6139ff
                , $e6040000
                , $8139ff
                , $ee040000
                , $a139ff
                , $f6040000
                , $c239ff
                , $ff040000
                , $e239ff
                , $80000
                , $041ff
                , $8080000
                , $2041ff
                , $10080000
                , $4041ff
                , $18080000
                , $6141ff
                , $20080000
                , $8141ff
                , $29080000
                , $a141ff
                , $31080000
                , $c241ff
                , $39080000
                , $e241ff
                , $41080000
                , $04aff
                , $4a080000
                , $204aff
                , $52080000
                , $404aff
                , $5a080000
                , $614aff
                , $62080000
                , $814aff
                , $6a080000
                , $a14aff
                , $73080000
                , $c24aff
                , $7b080000
                , $e24aff
                , $83080000
                , $052ff
                , $8b080000
                , $2052ff
                , $94080000
                , $4052ff
                , $9c080000
                , $6152ff
                , $a4080000
                , $8152ff
                , $ac080000
                , $a152ff
                , $b4080000
                , $c252ff
                , $bd080000
                , $e252ff
                , $c5080000
                , $05aff
                , $cd080000
                , $205aff
                , $d5080000
                , $405aff
                , $de080000
                , $615aff
                , $e6080000
                , $815aff
                , $ee080000
                , $a15aff
                , $f6080000
                , $c25aff
                , $ff080000
                , $e25aff
                , $c0000
                , $062ff
                , $80c0000
                , $2062ff
                , $100c0000
                , $4062ff
                , $180c0000
                , $6162ff
                , $200c0000
                , $8162ff
                , $290c0000
                , $a162ff
                , $310c0000
                , $c262ff
                , $390c0000
                , $e262ff
                , $410c0000
                , $06aff
                , $4a0c0000
                , $206aff
                , $520c0000
                , $406aff
                , $5a0c0000
                , $616aff
                , $620c0000
                , $816aff
                , $6a0c0000
                , $a16aff
                , $730c0000
                , $c26aff
                , $7b0c0000
                , $e26aff
                , $830c0000
                , $073ff
                , $8b0c0000
                , $2073ff
                , $940c0000
                , $4073ff
                , $9c0c0000
                , $6173ff
                , $a40c0000
                , $8173ff
                , $ac0c0000
                , $a173ff
                , $b40c0000
                , $c273ff
                , $bd0c0000
                , $e273ff
                , $c50c0000
                , $07bff
                , $cd0c0000
                , $207bff
                , $d50c0000
                , $407bff
                , $de0c0000
                , $617bff
                , $e60c0000
                , $817bff
                , $ee0c0000
                , $a17bff
                , $f60c0000
                , $c27bff
                , $ff0c0000
                , $e27bff
                , $100000
                , $083ff
                , $8100000
                , $2083ff
                , $10100000
                , $4083ff
                , $18100000
                , $6183ff
                , $20100000
                , $8183ff
                , $29100000
                , $a183ff
                , $31100000
                , $c283ff
                , $39100000
                , $e283ff
                , $41100000
                , $08bff
                , $4a100000
                , $208bff
                , $52100000
                , $408bff
                , $5a100000
                , $618bff
                , $62100000
                , $818bff
                , $6a100000
                , $a18bff
                , $73100000
                , $c28bff
                , $7b100000
                , $e28bff
                , $83100000
                , $094ff
                , $8b100000
                , $2094ff
                , $94100000
                , $4094ff
                , $9c100000
                , $6194ff
                , $a4100000
                , $8194ff
                , $ac100000
                , $a194ff
                , $b4100000
                , $c294ff
                , $bd100000
                , $e294ff
                , $c5100000
                , $09cff
                , $cd100000
                , $209cff
                , $d5100000
                , $409cff
                , $de100000
                , $619cff
                , $e6100000
                , $819cff
                , $ee100000
                , $a19cff
                , $f6100000
                , $c29cff
                , $ff100000
                , $e29cff
                , $140000
                , $0a4ff
                , $8140000
                , $20a4ff
                , $10140000
                , $40a4ff
                , $18140000
                , $61a4ff
                , $20140000
                , $81a4ff
                , $29140000
                , $a1a4ff
                , $31140000
                , $c2a4ff
                , $39140000
                , $e2a4ff
                , $41140000
                , $0acff
                , $4a140000
                , $20acff
                , $52140000
                , $40acff
                , $5a140000
                , $61acff
                , $62140000
                , $81acff
                , $6a140000
                , $a1acff
                , $73140000
                , $c2acff
                , $7b140000
                , $e2acff
                , $83140000
                , $0b4ff
                , $8b140000
                , $20b4ff
                , $94140000
                , $40b4ff
                , $9c140000
                , $61b4ff
                , $a4140000
                , $81b4ff
                , $ac140000
                , $a1b4ff
                , $b4140000
                , $c2b4ff
                , $bd140000
                , $e2b4ff
                , $c5140000
                , $0bdff
                , $cd140000
                , $20bdff
                , $d5140000
                , $40bdff
                , $de140000
                , $61bdff
                , $e6140000
                , $81bdff
                , $ee140000
                , $a1bdff
                , $f6140000
                , $c2bdff
                , $ff140000
                , $e2bdff
                , $180000
                , $0c5ff
                , $8180000
                , $20c5ff
                , $10180000
                , $40c5ff
                , $18180000
                , $61c5ff
                , $20180000
                , $81c5ff
                , $29180000
                , $a1c5ff
                , $31180000
                , $c2c5ff
                , $39180000
                , $e2c5ff
                , $41180000
                , $0cdff
                , $4a180000
                , $20cdff
                , $52180000
                , $40cdff
                , $5a180000
                , $61cdff
                , $62180000
                , $81cdff
                , $6a180000
                , $a1cdff
                , $73180000
                , $c2cdff
                , $7b180000
                , $e2cdff
                , $83180000
                , $0d5ff
                , $8b180000
                , $20d5ff
                , $94180000
                , $40d5ff
                , $9c180000
                , $61d5ff
                , $a4180000
                , $81d5ff
                , $ac180000
                , $a1d5ff
                , $b4180000
                , $c2d5ff
                , $bd180000
                , $e2d5ff
                , $c5180000
                , $0deff
                , $cd180000
                , $20deff
                , $d5180000
                , $40deff
                , $de180000
                , $61deff
                , $e6180000
                , $81deff
                , $ee180000
                , $a1deff
                , $f6180000
                , $c2deff
                , $ff180000
                , $e2deff
                , $1c0000
                , $0e6ff
                , $81c0000
                , $20e6ff
                , $101c0000
                , $40e6ff
                , $181c0000
                , $61e6ff
                , $201c0000
                , $81e6ff
                , $291c0000
                , $a1e6ff
                , $311c0000
                , $c2e6ff
                , $391c0000
                , $e2e6ff
                , $411c0000
                , $0eeff
                , $4a1c0000
                , $20eeff
                , $521c0000
                , $40eeff
                , $5a1c0000
                , $61eeff
                , $621c0000
                , $81eeff
                , $6a1c0000
                , $a1eeff
                , $731c0000
                , $c2eeff
                , $7b1c0000
                , $e2eeff
                , $831c0000
                , $0f6ff
                , $8b1c0000
                , $20f6ff
                , $941c0000
                , $40f6ff
                , $9c1c0000
                , $61f6ff
                , $a41c0000
                , $81f6ff
                , $ac1c0000
                , $a1f6ff
                , $b41c0000
                , $c2f6ff
                , $bd1c0000
                , $e2f6ff
                , $c51c0000
                , $0ffff
                , $cd1c0000
                , $20ffff
                , $d51c0000
                , $40ffff
                , $de1c0000
                , $61ffff
                , $e61c0000
                , $81ffff
                , $ee1c0000
                , $a1ffff
                , $f61c0000
                , $c2ffff
                , $ff1c0000
                , $e2ffff);
